=== src/CMakeLists.txt ===
add_subdirectory(41_geometry)
add_subdirectory(42_nlstrain)
add_subdirectory(42_parser)
add_subdirectory(43_ptgroups)
add_subdirectory(43_wvl_wrappers)
add_subdirectory(44_abitools)
add_subdirectory(44_abitypes_defs)
add_subdirectory(45_geomoptim)
add_subdirectory(45_xgTools)
add_subdirectory(46_ghc_omp)
if(DO_BUILD_46_MANAGE_CUDA)
  add_subdirectory(46_manage_cuda)
endif()
if(DO_BUILD_44_MANAGE_KOKKOS)
  add_subdirectory(44_manage_kokkos)
endif()
add_subdirectory(48_diago)
add_subdirectory(49_gw_toolbox_oop)
add_subdirectory(51_manage_mpi)
add_subdirectory(52_fft_mpi_noabirule)
add_subdirectory(53_ffts)
add_subdirectory(54_spacepar)
add_subdirectory(55_abiutil)
add_subdirectory(56_io_mpi)
add_subdirectory(56_mixing)
add_subdirectory(56_recipspace)
add_subdirectory(56_xc)
add_subdirectory(57_iopsp_parser)
add_subdirectory(57_iovars)
add_subdirectory(61_occeig)
add_subdirectory(62_cg_noabirule)
add_subdirectory(62_ctqmc)
add_subdirectory(62_iowfdenpot)
add_subdirectory(62_poisson)
add_subdirectory(62_wvl_wfs)
add_subdirectory(64_psp)
add_subdirectory(65_lotf_base)
add_subdirectory(65_paw)
add_subdirectory(66_nonlocal)
add_subdirectory(66_vdwxc)
add_subdirectory(66_wfs)
add_subdirectory(67_common)

if(DO_BUILD_67_PYTHON_INVOCATION_EXT)
  add_subdirectory(67_python_invocation_ext)
endif()

if(DO_BUILD_67_TRIQS_EXT)
  add_subdirectory(67_triqs_ext)
endif()

add_subdirectory(68_dmft)
add_subdirectory(68_lotf)
add_subdirectory(68_recursion)
add_subdirectory(68_rsprc)
add_subdirectory(69_wfdesc)
add_subdirectory(70_gw)
add_subdirectory(71_bse)
add_subdirectory(71_wannier)
add_subdirectory(72_response)
add_subdirectory(77_ddb)
add_subdirectory(77_suscep)
add_subdirectory(78_effpot)
add_subdirectory(78_eph)
add_subdirectory(79_seqpar_mpi)
add_subdirectory(80_rttddft)
add_subdirectory(80_tdep)
add_subdirectory(94_scfcv)
add_subdirectory(95_drive)
add_subdirectory(98_main)
